use crate::runtime::{Variable, bool_get, bool_set};
use crate::interface::{ allocate::*, builder::* };

pub struct Boolean {
    managed:bool,
    addr:Variable,
}

impl Boolean {
    pub fn new() -> Self
    {
        let t = boolean();
        Self {
            managed:true,
            addr:Variable { class:t as usize, address: new(t) },
        }
    }

    pub fn set(&mut self, value:bool)
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { bool_set(mem, value) };
    }

    pub fn get(&self) -> bool
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { bool_get(mem) }
    }
}

impl Drop for Boolean {
    fn drop(&mut self) {
        if self.managed {
            delete(self.addr.address);
        }
    }
}
