use crate::runtime::{Variable, integer_get, integer_set};
use crate::interface::{ allocate::*, builder::* };

pub struct Integer {
    managed:bool,
    addr:Variable,
}

impl Integer {
    pub fn new() -> Self
    {
        let t = integer();
        Self {
            managed:true,
            addr:Variable { class:t as usize, address: new(t) },
        }
    }

    pub fn set(&mut self, value:i64)
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { integer_set(mem, value) };
    }

    pub fn get(&self) -> i64
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { integer_get(mem) }
    }
}

impl Drop for Integer {
    fn drop(&mut self) {
        if self.managed {
            delete(self.addr.address);
        }
    }
}
